Subject: F77 on an R10000 O2 Summary

From: Trevor Creamer <[email-masked]>
Date: Thu, 20 Feb 1997 14:44:32 -0500

-- 
________________________________________________________________________

 Trevor P. Creamer                          Kentucky Center for
 Email  - [email-masked]          Structural Biology
 Phone  - (606) 323 6037                    Dept. of Biochemistry
 Fax    - (606) 323 1037                    University of Kentucky
                                            Lexington, KY 40536-0084
 http://euripides.gws.uky.edu/~trevor       U.S.A.
________________________________________________________________________
Well, thanks for all the answers to my f77 compilation problems on an O2. I've
appended the answers below for those who requested a summary. I've also included
my original message at the very end. I gather there were two problems. 
Number one was that the 64-bit libraries are not loaded in the default 
installation. This was pointed out to me by a couple of people.
Number two was pointed out by Omar Stradella from SGI (see below): apparently
the O2's don't support 64-bit binaries (is this really true ?). You can take
advantage of the mips4 instruction set using:

	f77 -n32 -mips4....

Thanks again,
	      Trevor

+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

From: [email-masked] (Serge Pachkovsky)

> I get the following error from the linker:
> 
> ld64: FATAL 9: I/O error (/usr/lib64/crt1.o): No such file or directory
> f77 INTERNAL ERROR:  /usr/lib32/cmplrs/ld64 returned non-zero status 32
> 
> Sure enough, crt1.o does not exist in /usr/lib64. I can compile with no
> problems using:

Install compiler_dev.sw64.*, compiler_eoe.sw64.* and ftn_dev.sw64.*
subsystems from your IDO CD. You might also want to install other 64-bit
subsystems, such as complib.sw.sgimath_64, but these three are absolutely
necessary to link -64 executables. Likewise, if you want to compile
-n32 executables, install *.sw32.* subsystems. 

Generally, you can get a fairly good idea which subsystems you'd need
by reading release notes (use relnotes or grelnotes, depending on your
UI preferences). 

Regards,

/Serge.P

+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

From: "Dr D.W. Lewis" <[email-masked]>

We have had nothing but problems with this as well! The compilers are
basically very poor (would SGI like to deny that?). The problem is 
mainly caused IMO (as I think you have noticed) by the 32-bit nature of
Irix6.3 whilst the compiler is expecting an R10000 to support 64 bit
stuff. The best I can do is say lower you optimisation to -O and it
will probably work! I would check your code against another SG system
as well if possible especially if you do ramp up the ooptimisation.
I am getting rouding errors in some routines with -O3 on the O2.

Having said that we have had reasonably good response from the 
software support at SGI - they seem aware and embarrassed at least.
Raise it with them via their support line and see if you can get 
anything out of them. They jumped pretty quick when we said that the
standard LAPACK routine failed to give correct test suite answers.

I know its not much of a consolation but the C compiler seems better!
But I won't be buying another O2......
----------------------------------------------------------------------------
Dr. Dewi W. Lewis                           
Dept of Materials Science and Metallurgy,     Email: [email-masked]
University of Cambridge, Pembroke St.,               Phone: +44 1223 3 34496
Cambridge, CB2 3QZ, UK                                 Fax: +44 1223 3 34567
				WWW: http://www-img.msm.cam.ac.uk/D.W.Lewis/

+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

From: Raf Bruyndonckx <[email-masked]>

Hello Trevor,

see if you can find "/usr/lib64/cmplrs/f77" , and if you have it, try
that compiler. Otherwise, be sure you have all the 64-bit libraries and
executables installed. Standard installation can skip some parts from
the distribution and even using custom installation you miss sometimes a
few.

I hope this will help.

Raf

-- 

Raf Bruyndonckx
Department of Inorganic Chemistry
Univ Fribourg (Suisse)
Perolles

Tel: ++41 26 300 87 49
Fax: ++41 26 300 97 38

mailto:[email-masked]

http://www.unifr.ch/

+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

From: "Peter Shenkin" <[email-masked]>

I seem to recall that this is due to some installation bug.
Assuming you're under support, call SGI.

	Best,
	-P.

-- 
** Religion is OK, if practiced behind closed doors by consenting adults **
* Peter S. Shenkin; Chemistry, Columbia U.; 3000 Broadway, Mail Code 3153 *
** NY, NY  10027;  [email-masked];  (212)854-5143;  FAX: 678-9039 ***
MacroModel WWW page: http://www.cc.columbia.edu/cu/chemistry/mmod/mmod.html

+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

From: "Omar G. Stradella" <[email-masked]>

Hi Trevor,

The O2 does not support execution of 64 bit binaries. To take advantage
of the new insctuction set anyway, compile with -n32 -mips4.

Omar.

+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

On Feb 20,  9:48am, Trevor Creamer wrote:
> Subject: CCL:F77 on an R10000 O2
> My apologies in advance if this is an inappropriate post...
>
> I have just migrated from a R4400 SGI platform running IRIX 5.3 to a new
> R10000 O2 running IRIX 6.3 and I'm having problems getting my (very
> standard) Fortran programs to compile in 64-bit mode. If I compile
> using:
>
> 	f77 -O3 -mips4 myprog.f   (or f77 -O3 -64 myprog.f)
>
> I get the following error from the linker:
>
> ld64: FATAL 9: I/O error (/usr/lib64/crt1.o): No such file or directory
> f77 INTERNAL ERROR:  /usr/lib32/cmplrs/ld64 returned non-zero status 32
>
> Sure enough, crt1.o does not exist in /usr/lib64. I can compile with no
> problems using:
>
> 	f77 -O3 -32 myprog.f
>
> - crt1.o does exist in /usr/lib32.
>
> I have gone through the Development Option 7.0.1 and Developer Update
> Package (10/96) cd's throughly and there is nothing that hasn't been
> installed. Has anyone else run into this ? Any suggestions ?
> Cheers,
> 	Trevor